// paracalc_test.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include <windows.h>
#include <tchar.h>
#include "..\paracalc\calc.h"

// fobOo
void OutputDebug(LPCTSTR lpFormat, ...) {
	va_list args;
	va_start(args, lpFormat);
	TCHAR message[2048];
	_vstprintf_s(message, 2048, lpFormat, args);
	OutputDebugString(message);
}

void Assert(LPCTSTR lpActual, LPCTSTR lpExpected) {
	TCHAR lpResult[1024] = {0};
	Calc(lpExpected, lpResult, 1024);
	if (_tcscmp(lpActual, lpResult) != 0) {
		OutputDebug(_T("s: [%s] expected [%s]. but was [%s]\n"),
			lpActual, lpExpected, lpResult);
	}
}

void TestCalc(void) {
	//Z
	Assert(_T("3"), _T("1+2"));
	Assert(_T("24690"), _T("12345+12345"));

	//Z
	Assert(_T("5"), _T("10-5"));
	Assert(_T("0"), _T("12345-12345"));

	//Z
	Assert(_T("6"), _T("2*3"));
	Assert(_T("152399025"), _T("12345*12345"));

	//Z
	Assert(_T("2"), _T("6/3"));
	Assert(_T("1"), _T("12345/12345"));

	//Zq
	Assert(_T("55"), _T("1+2+3+4+5+6+7+8+9+10"));
	Assert(_T("7"), _T("1+2*3"));

	//
	Assert(_T("9"), _T("(1+2)*3"));
	Assert(_T("-3"), _T("(1+2)*(3-4)"));

	//󔒌
	Assert(_T("7"), _T("   1   +   2   *   3"));
	Assert(_T("7"), _T("	1	+	 2		*   3		"));

	//QoCg
	Assert(_T("7"), _T("P{QR"));
	Assert(_T("-5"), _T("P[Q~R"));
	Assert(_T("-5"), _T("P\Q~R"));
	Assert(_T("-5"), _T("P|Q~R"));
	Assert(_T("-5"), _T("P]Q~R"));
}

//C
int _tmain(int argc, _TCHAR* argv[]) {
	TestCalc();

	return 0;
}

